#include "region.h"

//-------------------------------------------------------------------------
Region::Region()
: m_selected( false )
{
}
//-------------------------------------------------------------------------

//-------------------------------------------------------------------------
Region::Region( vector<Point> _pts,
                vector<Curve*> _curves, vector<bool> _curveOrients )
: m_selected( false )
{
 this->m_pts = _pts;
 this->m_curves = _curves;
 this->m_curveOrients = _curveOrients;
}
//-------------------------------------------------------------------------

//-------------------------------------------------------------------------
Region::~Region()
{
}
//-------------------------------------------------------------------------

//-------------------------------------------------------------------------
void 
Region::getBoundBox( double* _xmin, double* _xmax,
                     double* _ymin, double* _ymax )
{
 if( m_pts.size() < 1 )
  return;

 *_xmin = *_xmax = m_pts[0].getX();
 *_ymin = *_ymax = m_pts[0].getY();

 if( m_pts.size() == 1 )
  return;

 for (int j = 1; j < m_pts.size(); j++)
 {
  if( m_pts[j].getX() < *_xmin) *_xmin = m_pts[j].getX();
  if( m_pts[j].getX() > *_xmax) *_xmax = m_pts[j].getX();
  if( m_pts[j].getY() < *_ymin) *_ymin = m_pts[j].getY();
  if( m_pts[j].getY() > *_ymax) *_ymax = m_pts[j].getY();
 }
}
//-------------------------------------------------------------------------
